

#include <Servo.h>  //Rather then "digitalWrite", the Servo Library is used to control the continuous rotation servo.
Servo servo1;
int forward = 7;    //Pin 7 HIGH is used as the input to extend the actuator (remember a pull down resistor)
int reverse = 8;    //Pin 8 HIGH is used as the input to retract the actuator (remember a pull down resistor) 
int fLimit = 5;     //Pin 5 LOW is used as the input from the sensor to stop extending the actuator (remember a 20k pull up resistor)
int rLimit = 6;     //Pin 6 LOW is used as the input from the sensor to stop retracting the actuator (remember a 20k pull up resistor)

void setup() {

  pinMode(5, INPUT);  //Pins 5,6,7, & 8 are the input pins described aboive
  pinMode(6, INPUT);  
  pinMode(7, INPUT);
  pinMode(8, INPUT);
  pinMode(9, OUTPUT); //Pin 9 is used for the Servo output - to extend and retract (forward and reverse)
}

void loop() {
  
  //The following "while" loops cover the vaious states of the actuator inputs - extend, retract, and associated limit sensors.  
  //Tying an individual LED output to each of the "while" loops creates a intuitive operating enviorment and can help with trouble shooting.
  
  //FORWARD - Forward limit sensor not made
  //The servo must be attached each time it is run because the method of fully stopping the servo is to detach it.
  //The servo1.write value of 40 is a value that causes the continuous rotation servo to turn counter clockwise at full speed,
  //this value was determind by trying differant values and may be differant for your continuous rotation servo.
  while(digitalRead(forward) == HIGH && digitalRead(reverse) == LOW && digitalRead(fLimit) == HIGH) {
    servo1.attach(9);
    servo1.write(40); } 
    
  //FORWARD - Forward limit sensor made
  //When either of the limit sensors are made (and go LOW) the servo is fully detached to stop any rotation.
  while(digitalRead(forward) == HIGH && digitalRead(reverse) == LOW && digitalRead(fLimit) == LOW) {
    servo1.detach(); }
  
  //REVERSE - Reverse limit sensor not made
  //The servo1.write value of 150 is a value that causes the continuous rotation servo to turn clockwise at full speed,
  //this value was determind by trying differant values and may be differant for your continuous rotation servo.
  while(digitalRead(forward) == LOW && digitalRead(reverse) == HIGH && digitalRead(rLimit) == HIGH){
    servo1.attach(9);  
    servo1.write(150); }  
    
  //REVERSE - Reverse limit sensor made
  //When either of the limit sensors are made (and go LOW)the servo is fully detached to stop any rotation.
  while(digitalRead(forward) == LOW && digitalRead(reverse) == HIGH && digitalRead(rLimit) == LOW){
    servo1.detach(); }      
    
  //STOP, DUAL LOW SIGNAL
  //The servo is detcahed when there is no signal for forward or reverse
  while(digitalRead(forward) == LOW && digitalRead(reverse) == LOW){
    servo1.detach(); }
    
  //STOP, ERROR, DUAL HIGH SIGNAL
  //This covers the inadvertant case when there is a signal to both forward and reverse.  
  while(digitalRead(forward) == HIGH && digitalRead(reverse) == HIGH){
    servo1.detach(); }   
} 
